#include <windows.h>
#pragma hdrstop
#include <condefs.h>
#include <strstrea.h>
#include "UseDLLFunction1.h"

USEUNIT("UseDLLFunction1.cpp");
//---------------------------------------------------------------------------
#define ALLOCANZAHL 100

HINSTANCE        hDLLInst;
int             *x[ALLOCANZAHL];
UseDLLFunction1  xxx;

void fnAllocMemory();

//==============================================================================
//
//==============================================================================
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hInst, DWORD dwReason, void* pvReserved)
{
   switch (dwReason)
   {
      case DLL_PROCESS_ATTACH: // DLL Start = LoadLibrary
           //-------------------------------------------------------------------
           // Handle global sichern, wird fr einige WINDOWS-Befehle bentigt
           //-------------------------------------------------------------------
           hDLLInst = hInst;
           fnAllocMemory();
           break;

      case DLL_PROCESS_DETACH: // DLL Ende = FreeLibrary
           break;
   }
   return 1;
}

//==============================================================================
//
//==============================================================================
void fnAllocMemory()
{
   strstream szInfo;
   int i    = 0;
   int ende = 0;

   while (i<ALLOCANZAHL && !ende)
   {
      x[i] = new int [30000];
      if (!x[i]) ende = 1;
      i++;
   }

   szInfo << i << " x 60kB angelegt";
   MessageBox (NULL, szInfo.str(), "dyn. Allokation", MB_OK);
}

//==============================================================================
//
//==============================================================================
extern "C" UseDLLFunctionBase * FAR _export DoSomeThing (void)
{
   for (int i=0; i<ALLOCANZAHL; i++)
   {
      if (x[i])
      {
         delete [] x[i];
       	 x[i] = NULL;
      }
   }

   MessageBox (NULL, "alles freigegeben", "x", MB_OK);
   return &xxx;
}
